#define NPC_INCLUDED
#ifndef PUBLIC_INCLUDED
#include "publicInc.h"
#endif



#ifndef OBJLIST_INCLUDED
#include "objlist.h"
#endif



typedef struct npc_baseinfo
{
	//----------npc definition----------
	char					div;		//1:npc, 2:monster
	char					gtype;	//
	unsigned short		npc_id; //̵( ȣ)

	unsigned short		x;
	unsigned short		y;
	unsigned short		dx;
	unsigned short		dy;
	unsigned short		speed;

	char					DirLoc;
	unsigned short		ARx;//array index
	unsigned short		ARy;
	unsigned short		BSx;			// 
	unsigned short		BSy;			//

	unsigned short		Gx;			//gen
	unsigned short		Gy;			//gen

	short					level;

	short					tHP;
	short					HP;
	unsigned short		AP;
	unsigned short		DP;

	unsigned short		EXP;

	char					bat_type;//Ÿ ,İ,+A
	char					sk_stat;//npc 

	unsigned short		status;//npc..
	unsigned short		mvstatus;//npc..

	unsigned short		targetNO;
	void			*		targetChr;
	char					tgFlag;		//0: flag off 1: Ÿ 

	unsigned short		Sight;	//þ..
	unsigned short		tgLen;	//Ÿ.

	unsigned short		recov_F_cnt;//ȸ ī..
	unsigned short		move_F_cnt;//ӿ ī..
	unsigned short		heat_F_cnt;//Ÿݿ ī..
	unsigned short		active_F_cnt;// ī..
	unsigned short		rotate_F_cnt;//ȸ ī..
	unsigned short		ret_F_cnt;//ǵư ī..
	unsigned short		wait_F_cnt;//ٸ ī..
	unsigned short		regen_F_cnt;// ī..
}
type_npc;



typedef struct npcmapsys
{
	type_objlist *	objL;
}
type_npcmap;



typedef struct npc_default
{
	unsigned short no;
	unsigned short gtype;
	unsigned short level;
	unsigned short speed;

	unsigned short item[12];
	unsigned short rate[12];
} type_gnpc;



extern void * voidnpclist_get_first(type_objlist const * const * * save,unsigned short i, unsigned short j);
extern void * voidnpclist_get_next(type_objlist const * const * * save);

extern void npc_set_def(char div, short no, char gtype, char level, char speed,short * item,char * rate);
extern void npc_set(char div,short no,short x,short y);
extern void npc_mapinit(type_npc * npc);


extern void npc_1x1_sectorinfo(unsigned short x, unsigned short y,void * session);//1  ۽
extern void npc_3x3_secterinfo(void * session);//3x3  ۽
extern void npc_mv_addinfo(type_npc * npc);//npc  ̵ ۽
extern void npc_chr_mv_addinfo(void * session);//ɸ  ̵ npc ۽

extern void npc_attack_chr(void * chrr, unsigned short idx);
extern void npc_chr_die(unsigned short npcId, void * chrr);
extern int npc_mv_one(type_npc * npc);
extern void npc_mv_set(unsigned short idx);
extern void npc_regen(unsigned short idx);
extern type_npc * npc_ret_fight(unsigned short idx);
extern int npc_ret_dist(unsigned short x, unsigned short y, unsigned short idx);//x,y ǥ, idx=index

extern short npc_chr_attack_npc(void * chr, unsigned short Index,void * conn);
extern short npc_drop_item(type_npc * npc, unsigned short userNo);

extern void npc_skill_1(void * chr,unsigned short pwr, unsigned short xx, unsigned short yy,char * gDat,void * conn);
